function [alpha,X]=BoundSDP3(P,kv)
% Compute relaxation bound on alpha
[n,nk]=size(P);
disp('-------------------------------------------------------------------------------------');
disp('Solve SDP relaxation using SDPT3');
if kv>1
    nn=n*(n+1)/2;
    nkn=(n+nk)*(n+nk+1)/2;
    clear blk;blk{1,1}='s';blk{1,2}=(n+nk);blk{1,3}=[2*ones(1,3*nn),2*ones(1,n^2)]; % Low rank SDP constraints
    At{1,1}=sparse(nkn,nn+3);At{1,2}=[];At{1,3}=[];
    [Vb,Db]=eig([0 1; 1 0]);em=eye(n);
    for j=1:n;for i=1:j
            At{1,2}=[At{1,2},[P(i,:)',P(j,:)';zeros(n,2)]*Vb];
            if (i==j);At{1,3}=[At{1,3};[-1/2;1/2]];
            else At{1,3}=[At{1,3};[-1;1]];
            end; end
    end
    for j=1:n; for i=1:j
            At{1,2}=[At{1,2},[zeros(nk,2);em(:,i),em(:,j)]*Vb];
            if (i==j); At{1,3}=[At{1,3};[-1/2;1/2]];
            else; At{1,3}=[At{1,3};[-1;1]];
            end; end
    end
    for j=1:n; for i=1:j
            At{1,2}=[At{1,2},[zeros(nk,2);em(:,i),em(:,j)]*Vb];
            if (i==j); At{1,3}=[At{1,3};[-1/2;1/2]];
            else; At{1,3}=[At{1,3};[-1;1]];
            end; end
    end
    for j=1:n; for i=1:n
            At{1,2}=[At{1,2},[P(i,:)',zeros(nk,1);zeros(n,1),em(:,j)]*Vb];
            At{1,3}=[At{1,3};[-1;1]*0.5];
        end
    end
    C{1,1}=[zeros(nk,nk),-0.5*P';-0.5*P,zeros(n,n)];
    blk{2,1}='l';blk{2,2}=6*nn+2*n^2; % Block linear constraints (switch U4 and U1)
    vv=svec({'s',n},ones(n,n));[ii,jj,vls]=find(speye(nn));dscal=sparse(ii,jj,vv.^2);
    AA=[sparse(nn,nn),-sparse(ones(nn,1)),sparse(nn,2),speye(nn),sparse(nn,2*nn+n^2)];
    AA=[AA;sparse(nn,nn),-sparse(ones(nn,1)),sparse(nn,2),-speye(nn),sparse(nn,2*nn+n^2)];
    AA=[AA;sparse(nn,nn),sparse(nn,1),-sparse(ones(nn,1)),sparse(nn,1),sparse(nn,nn),speye(nn),sparse(nn,nn+n^2)];
    AA=[AA;sparse(nn,nn),sparse(nn,1),-sparse(ones(nn,1)),sparse(nn,1),sparse(nn,nn),-speye(nn),sparse(nn,nn+n^2)];
    AA=[AA;-speye(nn),sparse(nn,3),sparse(nn,2*nn),dscal,sparse(nn,n^2)];
    AA=[AA;-speye(nn),sparse(nn,3),sparse(nn,2*nn),-dscal,sparse(nn,n^2)];
    AA=[AA;sparse(n^2,nn+2),-sparse(ones(n^2,1)),sparse(n^2,3*nn),-speye(n^2)];
    AA=[AA;sparse(n^2,nn+2),-sparse(ones(n^2,1)),sparse(n^2,3*nn),speye(n^2)];
    At{2,1}=AA; %clear AA;
    C{2,1}=sparse(6*nn+2*n^2,1);
    b=-[ones(nn,1);1;kv^2;kv;zeros(3*nn+n^2,1)]; % Objective
    OPTIONS.rmdepconstr = 1;
    %OPTIONS.gaptol=1e-2; %  Low target precision
    tic;[obj,X,y,Z]=sqlp(blk,At,C,b,OPTIONS);toc % Solve
    alpha=-b'*y;
    disp(['Result: ',num2str(-b'*y)])
else
    nn=n*(n+1)/2;
    nkn=(n+nk)*(n+nk+1)/2;
    clear blk;blk{1,1}='s';blk{1,2}=(n+nk);blk{1,3}=[2*ones(1,2*nn),2*ones(1,n^2)]; % Low rank SDP constraints
    At{1,1}=sparse(nkn,3);At{1,2}=[];At{1,3}=[];
    [Vb,Db]=eig([0 1; 1 0]);em=eye(n);
    for j=1:n;for i=1:j
            At{1,2}=[At{1,2},[P(i,:)',P(j,:)';zeros(n,2)]*Vb];
            if (i==j);At{1,3}=[At{1,3};[-1/2;1/2]];
            else At{1,3}=[At{1,3};[-1;1]];
            end; end
    end
    for j=1:n; for i=1:j
            At{1,2}=[At{1,2},[zeros(nk,2);em(:,i),em(:,j)]*Vb];
            if (i==j); At{1,3}=[At{1,3};[-1/2;1/2]];
            else; At{1,3}=[At{1,3};[-1;1]];
            end; end
    end
    for j=1:n; for i=1:n
            At{1,2}=[At{1,2},[P(i,:)',zeros(nk,1);zeros(n,1),em(:,j)]*Vb];
            At{1,3}=[At{1,3};[-1;1]*0.5];
        end
    end
    C{1,1}=[zeros(nk,nk),-0.5*P';-0.5*P,zeros(n,n)];
    blk{2,1}='l';blk{2,2}=4*nn+2*n^2; % Block linear constraints (switch U4 and U1)
    AA=[-sparse(ones(nn,1)),sparse(nn,2),speye(nn),sparse(nn,nn+n^2)];
    AA=[AA;-sparse(ones(nn,1)),sparse(nn,2),-speye(nn),sparse(nn,nn+n^2)];
    AA=[AA;sparse(nn,1),-sparse(ones(nn,1)),sparse(nn,1),sparse(nn,nn),speye(nn),sparse(nn,n^2)];
    AA=[AA;sparse(nn,1),-sparse(ones(nn,1)),sparse(nn,1),sparse(nn,nn),-speye(nn),sparse(nn,n^2)];
    AA=[AA;sparse(n^2,2),-sparse(ones(n^2,1)),sparse(n^2,2*nn),-speye(n^2)];
    AA=[AA;sparse(n^2,2),-sparse(ones(n^2,1)),sparse(n^2,2*nn),speye(n^2)];
    At{2,1}=AA; %clear AA;
    C{2,1}=sparse(4*nn+2*n^2,1);
    b=-[1;1;1;zeros(2*nn+n^2,1)]; % Objective
    OPTIONS.rmdepconstr = 1;
    %OPTIONS.gaptol=1e-2; %  Low target precision
    tic;[obj,X,y,Z]=sqlp(blk,At,C,b,OPTIONS);toc % Solve
    alpha=-b'*y;
    disp(['Result: ',num2str(-b'*y)])
end
disp('-------------------------------------------------------------------------------------');