% Test projection on l_inf ball

% generate random data matrix
randn('state',33);
n = 1000;
x0=randn(n,1);
%lambda=2*(sx0(1)-sx0(2))+4*(sx0(2)-sx0(3))+6*(sx0(3)-sx0(4));
lambda=100;

tic
y=LinfProj(x0,lambda);
toc

if 1
tic
% Direct solution
sgnx0=sign(x0);x0=abs(x0);
if lambda>2*sum(x0)
    xdf=zeros(size(x0));
else
    [sx0,idx]=sort(x0,'descend');[zz,ividx]=sort(idx);
    avg=diag(1./(1:n))*tril(ones(n,n))*sx0;
    cmpv=avg-(lambda/2)./(1:n)';
    idxf=find(sx0>=cmpv);
    xdf=sx0;xdf(idxf)=(sum(sx0(idxf))-lambda/2)/length(idxf);
end
xdff=sgnx0.*xdf(ividx);x0=sgnx0.*x0;
%[x0,xdff,y]
toc
norm(xdff-y)
end 


if 0
% solve using cvx
cvx_begin
   variable x(n)
   minimize( (x-x0)'*(x-x0) + lambda*max(abs(x)));
cvx_end
end


if 0
% Pathwise solution
tic;
sgnx0=sign(x0);
x0=abs(x0);
[sx0,idx]=sort(x0,'descend');[zz,ividx]=sort(idx);
xdf=sx0(1:end)-[sx0(2:end);0];
bkpts=[0;tril(ones(n,n))*2*((1:n)'.*xdf)];
if lambda>=bkpts(end)
    xf=zeros(n,1);
else
    ix=max(find(lambda>=bkpts(1:n)));
    sx=sx0-triu(ones(n,ix-1))*xdf(1:ix-1)-[ones(ix,1);zeros(n-ix,1)]*(lambda-bkpts(ix))/(2*ix);
end
xf=sgnx0.*sx(ividx)
toc
end

if 0
tic
xf=LinfProj(x0,lambda);
[x,xf]
norm(x-xf)
toc
end


if 0
[sx0,idx]=sort(abs(x0),'descend');
vd=sum(tril(ones(n,1)*sx0'-sx0*ones(1,n))'.^2)+lambda*sx0';
ust=sum(triu(sx0*ones(1,n)))-lambda/2;
ust=ust.*(ust<sx0');
ust=ust.*(ust>[sx0(2:end);0]');
ust(find(ust==0))=Inf;
vc=sum(tril(ones(n,1)*sx0'-ust'*ones(1,n))'.^2)+lambda*ust;
[vm,im]=min([vd,vc]);upos=[sx0',ust];um=upos(min(im));
end

