% Compute CPU time vs problem size
% Test semidefinite relaxation for nullspace property
addpath('./JNcode');
addpath('./SmoothCode');

% Types:
% 1    strF='Fourier';
% 3    str1='+1/-1';
% 4    strG='Gauss';
% 9    strV='DeVore';

% Test params
alphab=0.5;
rho=.7;
nsamp=1;
%nrange=[50,100,200,500];
nrange=[25,50];

% Algo params
maxiter=10000;
infov=10;
tol=0.01;


if 1
res=[];count=1;
% Iterate over many samples
for n=nrange
        for smp=1:nsamp
            m = round(rho*n);
            kv=1;
            % Generate matrix
            [rss,pnt]=AAGenerateSensingMatrix(4,n,m);
            A=rss.A;n=rss.n;m=rss.m;
            P=null(A);nk=size(P,2);
            % Launch smooth code
            tic;[Y,G,fmu,gaphist,cpuhist] = SmoothNullPropEUC(A,kv,alphab,tol,maxiter,infov);toc;
            % Display results
            resbuf=[n,smp,kv,max(fmu),min(gaphist(:,2)),toc];
            disp('**************************************************************************************************');
            disp(sprintf('Results: done %d out of %d...',count,length(nrange)*nsamp));
            disp(num2str(resbuf));
            disp('**************************************************************************************************');
            res=[res;resbuf];count=count+1;
        end
end
res
for i=1:size(res(:,1))
    t1=res(i,6);
    thours = fix(t1/3600); 
    tmins = fix((t1-thours*3600)/60); 
    tsecs = fix(t1-thours*3600-tmins*60); 
    txt = ['%2.0f h %2.0f m']; 
    txt = sprintf(txt,thours,tmins);
    disp(txt)
end
end



if 0
    clk=clock;
    datestmp=strcat([date,'-',num2str(clk(4)),'h',num2str(clk(5))])
    save(strcat('StatsCPU-',datestmp))
end